---

name: build

on: [push]

concurrency:
  group: ${{ github.workflow }}--${{ github.ref }}
  cancel-in-progress: true

jobs:
  build:
    runs-on: ${{ matrix.os }}

    strategy:
      matrix:
        os: [ubuntu-20.04, macos-12, windows-2022]

    steps:

    - uses: actions/checkout@v3

    - uses: actions/setup-python@v4
      with:
        python-version: |
          2.7
          3.5
          3.6
          3.7
          3.8
          3.9
          3.10
          3.11

    - run: python3 -m pip install tox~=4.4.0 virtualenv~=20.21.0

    - run: python3 -m tox run

    - uses: actions/upload-artifact@v3
      if: always()
      with:
        name: log-${{ matrix.os }}
        path: |
          .tox/py*/log
          .tox/py*/tmp/testenv
        if-no-files-found: ignore
